'
'   Copyright 2008   Radical Eye Software
'   frankenmod by cheezus -for P1 & P2
'   See end of file for terms of use.
'
#ifdef __P2__
CON
  _clkfreq = 160_000_000
  _clkmode = $010007f8
  
{    
    'Raymond's pins
    cs_pin=6
    clk_pin=11
    miso_pin=7
    mosi_pin=10
}

    ' P2-ES SD CARD
    do  = 58
    di  = 59
    cs  = 60
    clk = 61    
    
    testpin= 57     ' for LA CAPS

obj   term: "SimpleSerial.spin2"           ''-P2 TERM

#else
CON
        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000

    DO  = 24
    CLK = 25
    DI  = 26
    CS  = 27

  RXPIN=31        'Prop pins used for comms
  'TXPIN=30     ' for regular terminal
    
    TXPIN = 23      ' for LA CAPS
    testpin = 22    ' for LA CAPS

obj     term: "FullDuplexSerialExtended"

#endif

CON   Baudrate=115200    'baud rate for serial communications

dat     crlf  byte      13,10,0  

obj     sdfat: "fsrw.spin2"
   
var
   byte tbuf[20]
   byte bigbuf[8192]

pub go | x


#ifdef __P2__
   clkset(_clkmode, _clkfreq)
   waitcnt(cnt+clkfreq*2)
   
   outb[testpin-32] :=1
   dirb[testpin-32] :=1

#else
   outa[testpin] :=1
   dira[testpin] :=1
#endif

   waitcnt(cnt+clkfreq*1)



   x := \start
   
   
#ifdef __P2__
    outb[testpin-32] :=1
#else
    outa[testpin] :=1
#endif

   
   
   term.str(string("Returned from start", 13,10))
   term.dec(x)
   term.str(@crlf)
   
   
   
pub start | r, sta, bytes

   

#ifdef __P2__
    term.start(BaudRate) 'open comm port
#else
    term.start(RXPIN,TXPIN,0,BaudRate) 'open comm port
#endif

#ifdef __P2__
    outb[testpin-32] :=0
#else
    outa[testpin] :=0
#endif

   term.str(string("Mounting.", 13,10)) 
   
   
  

     if (result := sdfat.mount_explicit(DO, CLK, DI, CS)) < 0
        return     
     

   
   term.str(string("Mounted.", 13,10))
   term.str(string("Dir: ", 13,10))
   sdfat.opendir
   repeat while 0 == sdfat.nextfile(@tbuf)
      term.str(@tbuf)
      term.str(@crlf)
   term.str(string("That's the dir", 13,10))
   term.str(@crlf)
  
   
   sta := cnt
   r := sdfat.popen(string("speed.txt"), "w")
   repeat 256
      sdfat.pwrite(@bigbuf, 8192)
   sdfat.pclose
   r := cnt - sta
   term.str(string("Writing 2M took "))
   term.dec(r)
   term.str(@crlf)
   sta := cnt
   r := sdfat.popen(string("speed.txt"), "r")
   repeat 256
      sdfat.pread(@bigbuf, 8192)
   sdfat.pclose
   r := cnt - sta
   term.str(string("Reading 2M took "))
   term.dec(r)

   
   term.str(@crlf)
   term.str(string("That's, all, folks! 3", 13))
{{
'  Permission is hereby granted, free of charge, to any person obtaining
'  a copy of this software and associated documentation files
'  (the "Software"), to deal in the Software without restriction,
'  including without limitation the rights to use, copy, modify, merge,
'  publish, distribute, sublicense, and/or sell copies of the Software,
'  and to permit persons to whom the Software is furnished to do so,
'  subject to the following conditions:
'
'  The above copyright notice and this permission notice shall be included
'  in all copies or substantial portions of the Software.
'
'  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
'  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
'  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
'  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
'  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
'  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
}}


































